local addon = LibStub("AceAddon-3.0"):NewAddon("Battleground", "AceEvent-3.0")
addon:SetDefaultModuleState(false)

addon.landmarks = BG_LANDMARKS
local landmarks = BG_LANDMARKS

-- evt funcs
local CheckZone
local AnalyzeLandmarks
local AnalyzeTimeElapsed

-- random locals
local pois = {}
local oldzone = nil

function addon:OnEnable()
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA", CheckZone)
	CheckZone()
end

function AnalyzeLandmarks()
	for i = 1, GetNumMapLandmarks(), 1 do
		local name, desc, ti, x, y = GetMapLandmarkInfo(i)
		local old = pois[name]
		if landmarks[ti] and ( not old or old ~= ti ) then
			pois[name] = ti
			-- print("BG_P", name, unpack(landmarks[ti]))
			addon:SendMessage("Battleground_POIUpdate", name, ti)
		end
	end
end

function AnalyzeTimeElapsed(offset)
	local start = floor(GetBattlefieldInstanceRunTime()/1000)
	if start < offset then
		addon:SendMessage("Battleground_StartTimer", offset - start)
	else
		addon:SendMessage("Battleground_Started", start - offset)
	end
end

function CheckZone()
	if oldzone then
		wipe(pois)
		for name, module in addon:IterateModules() do module:Disable() end
		oldzone = nil
		addon:UnregisterEvent("WORLD_MAP_UPDATE")
	end
	SetMapToCurrentZone()
	local zone = GetMapInfo()
	local module = addon:GetModule(zone, true)
	if module then
		oldzone = zone
		module:Enable()
		addon:RegisterEvent("WORLD_MAP_UPDATE", AnalyzeLandmarks)
		AnalyzeLandmarks()
		AnalyzeTimeElapsed(module.starttimer or 122) -- default to 2 minutes
	end
end



